import { createActions, handleActions } from 'redux-actions';
import { isEmpty, keys, has } from 'lodash';
import axios from 'axios';

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

// A type of promise-like that resolves synchronously and supports only one observer

const _iteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator"))) : "@@iterator";

const _asyncIteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.asyncIterator || (Symbol.asyncIterator = Symbol("Symbol.asyncIterator"))) : "@@asyncIterator";

// Asynchronously call a function and send errors to recovery continuation
function _catch(body, recover) {
	try {
		var result = body();
	} catch(e) {
		return recover(e);
	}
	if (result && result.then) {
		return result.then(void 0, recover);
	}
	return result;
}

var getWithParamsUrl = function getWithParamsUrl(path, params) {
  var regex = /\[(.*?)\]/g;
  var replacePath;

  if (!isEmpty(params)) {
    replacePath = path.replace(regex, function (match, name, surname) {
      var replaceStr = "" + params[name];
      return replaceStr;
    });
  } else {
    replacePath = path;
  }

  return replacePath;
};

var fetchApi = function fetchApi(_ref5) {
  var api = _ref5.api,
      method = _ref5.method,
      url = _ref5.url,
      params = _ref5.paramsUrl,
      body = _ref5.body,
      config = _ref5.config;

  try {
    var _temp57 = function _temp57() {
      console.log('responseresponse', response);
      return response;
    };

    method = method.toLowerCase();
    var error = null;
    var response = null;
    var path = getWithParamsUrl(url, params);
    var res = null;

    var _temp58 = _catch(function () {
      var _temp54 = function () {
        if (method === 'get' || method === 'delete') {
          var _temp59 = function _temp59() {
            response = res;
          };

          var _temp60 = function () {
            if (!isEmpty(api)) {
              var _temp61 = function _temp61(_api$method) {
                function _temp41(_api$method2) {
                  _isEmpty21 ? _api$method2 : res = _api$method2;
                }

                return _isEmpty21 ? _temp41(res = _api$method) : Promise.resolve(api[method](path, config)).then(_temp41);
              };

              var _isEmpty21 = isEmpty(config);

              return _isEmpty21 ? Promise.resolve(api[method](path)).then(_temp61) : _temp61(0);
            } else {
              var _temp62 = function _temp62(_axios$method) {
                function _temp43(_axios$method2) {
                  _isEmpty22 ? _axios$method2 : res = _axios$method2;
                }

                return _isEmpty22 ? _temp43(res = _axios$method) : Promise.resolve(axios[method](path, config)).then(_temp43);
              };

              var _isEmpty22 = isEmpty(config);

              return _isEmpty22 ? Promise.resolve(axios[method](path)).then(_temp62) : _temp62(0);
            }
          }();

          return _temp60 && _temp60.then ? _temp60.then(_temp59) : _temp59(_temp60);
        } else {
          var _temp63 = function () {
            if (method === 'post' || method === 'put') {
              var _temp64 = function _temp64() {
                response = res;
              };

              var _temp65 = function () {
                if (!isEmpty(api)) {
                  var _temp66 = function _temp66(_api$method3) {
                    function _temp47(_api$method4) {
                      _isEmpty23 ? _api$method4 : res = _api$method4;
                    }

                    return _isEmpty23 ? _temp47(res = _api$method3) : Promise.resolve(api[method](path, body)).then(_temp47);
                  };

                  var _isEmpty23 = isEmpty(config);

                  return _isEmpty23 ? Promise.resolve(api[method](path, body, config)).then(_temp66) : _temp66(0);
                } else {
                  var _temp67 = function _temp67(_axios$method3) {
                    function _temp49(_axios$method4) {
                      _isEmpty24 ? _axios$method4 : res = _axios$method4;
                    }

                    return _isEmpty24 ? _temp49(res = _axios$method3) : Promise.resolve(axios[method](path, body)).then(_temp49);
                  };

                  var _isEmpty24 = isEmpty(config);

                  return _isEmpty24 ? Promise.resolve(axios[method](path, body, config)).then(_temp67) : _temp67(0);
                }
              }();

              return _temp65 && _temp65.then ? _temp65.then(_temp64) : _temp64(_temp65);
            } else {
              console.error('Ensure your method please');
            }
          }();

          if (_temp63 && _temp63.then) return _temp63.then(function () {});
        }
      }();

      if (_temp54 && _temp54.then) return _temp54.then(function () {});
    }, function (err) {
      error = err;
      console.log(err);
    });

    return Promise.resolve(_temp58 && _temp58.then ? _temp58.then(_temp57) : _temp57(_temp58));
  } catch (e) {
    return Promise.reject(e);
  }
};

var prepareActions = function prepareActions(val) {
  var newVal = val.replace(/[A-Z]/g, function (m) {
    return '_' + m;
  }).toUpperCase();
  return createActions("START_LOADING_" + newVal, "" + newVal, "STOP_LOADING_" + newVal, "ERROR_" + newVal);
};
var dispatchActions = function dispatchActions(data) {
  var dataFns = {};
  data === null || data === void 0 ? void 0 : data.map(function (val) {
    var dispatchPrepareActions = prepareActions(val === null || val === void 0 ? void 0 : val.name);
    var slice = 4;
    var index = 0;

    var _loop = function _loop() {
      var _extends2;

      var partsKeys = keys(dispatchPrepareActions).splice(index, slice);
      dataFns = _extends({}, dataFns, (_extends2 = {}, _extends2[(val === null || val === void 0 ? void 0 : val.name) + "Action"] = function Action(data) {
        if (data === void 0) {
          data = {};
        }

        return function (dispatch) {
          try {
            dispatch(dispatchPrepareActions[partsKeys[0]](true));

            try {
              has(val, 'setPayload') ? dispatch(dispatchPrepareActions[partsKeys[1]](val.setPayload(data))) : dispatch(dispatchPrepareActions[partsKeys[1]](data));
              dispatch(dispatchPrepareActions[partsKeys[2]](false));
            } catch (error) {
              dispatch(dispatchPrepareActions[partsKeys[2]](false));
              dispatch(dispatchPrepareActions[partsKeys[3]](error));
            }

            return Promise.resolve();
          } catch (e) {
            return Promise.reject(e);
          }
        };
      }, _extends2));
      index = index + slice;
    };

    while (index < keys(dispatchPrepareActions).length) {
      _loop();
    }
  });
  return dataFns;
};
var dispatchActionsWithApi = function dispatchActionsWithApi(data) {
  var dataFns = {};
  data === null || data === void 0 ? void 0 : data.map(function (val) {
    var api = val.api,
        name = val.name,
        url = val.url,
        method = val.method,
        config = val.config;
    var dispatchPrepareActions = prepareActions(name);
    var slice = 4;
    var index = 0;

    var _loop2 = function _loop2() {
      var _extends3;

      var partsKeys = keys(dispatchPrepareActions).splice(index, slice);
      dataFns = _extends({}, dataFns, (_extends3 = {}, _extends3[name + "Action"] = function Action(data) {
        return function (dispatch) {
          try {
            var res;
            dispatch(dispatchPrepareActions[partsKeys[0]](true));

            var _temp8 = _catch(function () {
              function _temp6() {
                has(val, 'setPayload') ? dispatch(dispatchPrepareActions[partsKeys[1]](val === null || val === void 0 ? void 0 : val.setPayload({
                  data: data,
                  res: res
                }))) : dispatch(dispatchPrepareActions[partsKeys[1]](res.data));
                dispatch(dispatchPrepareActions[partsKeys[2]](false));
              }

              var _temp5 = function () {
                if (!isEmpty(api)) {
                  var _temp9 = function _temp9(_fetchApi) {
                    function _temp(_fetchApi2) {
                      _has3 ? _fetchApi2 : res = _fetchApi2;
                    }

                    return _has3 ? _temp(res = _fetchApi) : Promise.resolve(fetchApi({
                      api: api,
                      method: method,
                      url: url,
                      body: method == 'get' ? '' : data,
                      config: config
                    })).then(_temp);
                  };

                  var _has3 = has(data, 'paramsUrl');

                  return _has3 ? Promise.resolve(fetchApi({
                    api: api,
                    method: method,
                    url: url,
                    paramsUrl: data === null || data === void 0 ? void 0 : data.paramsUrl,
                    body: has(data, 'body') && method == 'get' ? '' : data.body,
                    config: config
                  })).then(_temp9) : _temp9(0);
                } else {
                  var _temp10 = function _temp10(_fetchApi3) {
                    function _temp3(_fetchApi4) {
                      _has4 ? _fetchApi4 : res = _fetchApi4;
                    }

                    return _has4 ? _temp3(res = _fetchApi3) : Promise.resolve(fetchApi({
                      method: method,
                      url: url,
                      body: method == 'get' ? '' : data,
                      config: config
                    })).then(_temp3);
                  };

                  var _has4 = has(data, 'paramsUrl');

                  return _has4 ? Promise.resolve(fetchApi({
                    method: method,
                    url: url,
                    paramsUrl: data === null || data === void 0 ? void 0 : data.paramsUrl,
                    body: has(data, 'body') && method == 'get' ? '' : data.body,
                    config: config
                  })).then(_temp10) : _temp10(0);
                }
              }();

              return _temp5 && _temp5.then ? _temp5.then(_temp6) : _temp6(_temp5);
            }, function (error) {
              dispatch(dispatchPrepareActions[partsKeys[2]](false));
              dispatch(dispatchPrepareActions[partsKeys[3]](error));
            });

            return Promise.resolve(_temp8 && _temp8.then ? _temp8.then(function () {}) : void 0);
          } catch (e) {
            return Promise.reject(e);
          }
        };
      }, _extends3));
      index = index + slice;
    };

    while (index < keys(dispatchPrepareActions).length) {
      _loop2();
    }
  });
  return dataFns;
};

var actionsCondition = function actionsCondition(data) {
  var reducerMap = {};
  var initialState = {};
  data.map(function (val) {
    try {
      var _extends2, _extends3, _extends23;

      var key = val.key,
          stateKey = val.stateKey,
          initStateKey = val.initStateKey,
          setState = val.setState;
      var newVal = key.replace(/[A-Z]/g, function (m) {
        return '_' + m;
      }).toUpperCase();
      initialState = _extends({}, initialState, (_extends3 = {}, _extends3[stateKey] = _extends({}, initialState[stateKey], (_extends2 = {
        data: initStateKey
      }, _extends2["loading" + (key.charAt(0).toUpperCase() + key.slice(1))] = false, _extends2["error" + (key.charAt(0).toUpperCase() + key.slice(1))] = '', _extends2)), _extends3));

      if (has(val, 'anotherActions')) {
        val === null || val === void 0 ? void 0 : val.anotherActions.map(function (value) {
          var _extends4, _extends5;

          initialState = _extends({}, initialState, (_extends5 = {}, _extends5[stateKey] = _extends({}, initialState[stateKey], (_extends4 = {}, _extends4["loading" + ((value === null || value === void 0 ? void 0 : value.key.charAt(0).toUpperCase()) + (value === null || value === void 0 ? void 0 : value.key.slice(1)))] = false, _extends4["error" + ((value === null || value === void 0 ? void 0 : value.key.charAt(0).toUpperCase()) + (value === null || value === void 0 ? void 0 : value.key.slice(1)))] = '', _extends4)), _extends5));
        });
      }

      if (has(val, 'anotherActions')) {
        val.anotherActions.map(function (value) {
          var _extends14;

          var newAction = value === null || value === void 0 ? void 0 : value.key.replace(/[A-Z]/g, function (m) {
            return '_' + m;
          }).toUpperCase();
          reducerMap = _extends({}, reducerMap, (_extends14 = {}, _extends14[newAction] = {
            next: function next(state, action) {
              if (has(value, 'setState')) {
                var _extends6;

                return _extends({}, state, (_extends6 = {}, _extends6[stateKey] = _extends({}, state[stateKey], {
                  data: value === null || value === void 0 ? void 0 : value.setState(state[stateKey], action)
                }), _extends6));
              } else {
                var _extends7;

                return _extends({}, state, (_extends7 = {}, _extends7[stateKey] = _extends({}, state[stateKey], {
                  data: action === null || action === void 0 ? void 0 : action.payload
                }), _extends7));
              }
            }
          }, _extends14["START_LOADING_" + newAction] = {
            next: function next(state, action) {
              var _extends8, _extends9;

              return _extends({}, state, (_extends9 = {}, _extends9[stateKey] = _extends({}, state[stateKey], (_extends8 = {}, _extends8["loading" + ((value === null || value === void 0 ? void 0 : value.key.charAt(0).toUpperCase()) + (value === null || value === void 0 ? void 0 : value.key.slice(1)))] = true, _extends8)), _extends9));
            }
          }, _extends14["STOP_LOADING_" + newAction] = {
            next: function next(state, action) {
              var _extends10, _extends11;

              return _extends({}, state, (_extends11 = {}, _extends11[stateKey] = _extends({}, state[stateKey], (_extends10 = {}, _extends10["loading" + ((value === null || value === void 0 ? void 0 : value.key.charAt(0).toUpperCase()) + (value === null || value === void 0 ? void 0 : value.key.slice(1)))] = false, _extends10)), _extends11));
            }
          }, _extends14["ERROR_" + newAction] = {
            next: function next(state, action) {
              var _extends12, _extends13;

              return _extends({}, state, (_extends13 = {}, _extends13[stateKey] = _extends({}, state[stateKey], (_extends12 = {}, _extends12["error" + ((value === null || value === void 0 ? void 0 : value.key.charAt(0).toUpperCase()) + (value === null || value === void 0 ? void 0 : value.key.slice(1)))] = action.payload, _extends12)), _extends13));
            }
          }, _extends14));
        });
      }

      reducerMap = _extends({}, reducerMap, (_extends23 = {}, _extends23[newVal] = {
        next: function next(state, action) {
          if (has(val, 'setState')) {
            var _extends15;

            return _extends({}, state, (_extends15 = {}, _extends15[stateKey] = _extends({}, state[stateKey], {
              data: setState(state[stateKey], action)
            }), _extends15));
          } else {
            var _extends16;

            return _extends({}, state, (_extends16 = {}, _extends16[stateKey] = _extends({}, state[stateKey], {
              data: action === null || action === void 0 ? void 0 : action.payload
            }), _extends16));
          }
        }
      }, _extends23["START_LOADING_" + newVal] = {
        next: function next(state, action) {
          var _extends17, _extends18;

          return _extends({}, state, (_extends18 = {}, _extends18[stateKey] = _extends({}, state[stateKey], (_extends17 = {}, _extends17["loading" + (key.charAt(0).toUpperCase() + key.slice(1))] = true, _extends17)), _extends18));
        }
      }, _extends23["STOP_LOADING_" + newVal] = {
        next: function next(state, action) {
          var _extends19, _extends20;

          return _extends({}, state, (_extends20 = {}, _extends20[stateKey] = _extends({}, state[stateKey], (_extends19 = {}, _extends19["loading" + (key.charAt(0).toUpperCase() + key.slice(1))] = false, _extends19)), _extends20));
        }
      }, _extends23["ERROR_" + newVal] = {
        next: function next(state, action) {
          var _extends21, _extends22;

          return _extends({}, state, (_extends22 = {}, _extends22[stateKey] = _extends({}, state[stateKey], (_extends21 = {}, _extends21["error" + (key.charAt(0).toUpperCase() + key.slice(1))] = action.payload, _extends21)), _extends22));
        }
      }, _extends23));
      return Promise.resolve();
    } catch (e) {
      return Promise.reject(e);
    }
  });
  return handleActions(reducerMap, initialState);
};

export { actionsCondition, dispatchActions, dispatchActionsWithApi };
//# sourceMappingURL=index.modern.js.map
